/*-------------------------------------------------------------------------
|   rxtx is a native interface to serial ports in java.
|   Copyright 1997, 1998, 1999 by Trent Jarvi jarvi@ezlink.com.
|
|   This library is free software; you can redistribute it and/or
|   modify it under the terms of the GNU Library General Public
|   License as published by the Free Software Foundation; either
|   version 2 of the License, or (at your option) any later version.
|
|   This library is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
|   Library General Public License for more details.
|
|   You should have received a copy of the GNU Library General Public
|   License along with this library; if not, write to the Free
|   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--------------------------------------------------------------------------*/

package gnu.io;
import java.io.SyncFailedException;
public final class FD {

    /* this class if mainly used ot make sure I understand how FD's work */
    private int fd; 

    public static final FD in = GetFD(new FD(),0);
    public static final FD out = GetFD(new FD(),1);
    public static final FD err = GetFD(new FD(),2);

    /* stuff that should be done native */
    /* probably not implemented yet */
    public native boolean valid();
    public native void sync() throws SyncFailedException;
/*    private static native FD GetFD(FD fdObj, int desc); */
    private static FD GetFD(
       FD fdObj, 
       int desc
    )
    {
    /*System.out.println("Called GetFD() " + fdObj + " " + desc);*/
    return(fdObj);
    }


    /* silly debug routines */
    public void ShowFD() {
      System.out.println("fd = " + fd);
      System.out.println("err = " + err);
      System.out.println("out = " + out);
      System.out.println("in = " + in);
    }
    public void SetFD(int newfd) { fd = newfd;}
    public void SetERR(int newfd) { err.fd = newfd;}
    public void SetOUT(int newfd) { out.fd = newfd;}
    public void SetIN(int newfd) { in.fd = newfd;}
}
