/*-------------------------------------------------------------------------
|   rxtx is a native interface to serial ports in java.
|   Copyright 1997, 1998, 1999 by Trent Jarvi jarvi@ezlink.com.
|
|   This library is free software; you can redistribute it and/or
|   modify it under the terms of the GNU Library General Public
|   License as published by the Free Software Foundation; either
|   version 2 of the License, or (at your option) any later version.
|
|   This library is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
|   Library General Public License for more details.
|
|   You should have received a copy of the GNU Library General Public
|   License along with this library; if not, write to the Free
|   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
    This file is used to test the native library before release
    It displays the following functionality in rxtx/commapi

       1.  enumerating ports
       2.  opening a port
       3.  writing to a port
       4.  notification of data available
       5.  reading the port

--------------------------------------------------------------------------*/

import java.io.*;
import java.util.*;
import javax.comm.*;

public class test implements Runnable, SerialPortEventListener {
	static CommPortIdentifier ID;
	static Enumeration ports;

	SerialPort RXTXPort;
	InputStream in;
	OutputStream out;
	Thread readThread;

	public static void main(String[] args) {
		ports = CommPortIdentifier.getPortIdentifiers();
		while (ports.hasMoreElements()) {
			ID = (CommPortIdentifier) ports.nextElement();
			if (ID.getPortType()==CommPortIdentifier.PORT_SERIAL){
				if(ID.getName().equals("/dev/ttyS3")){
					test testread = new test();
				}
			}
		}
	}
	public test(){
		
                byte[] dump = {(byte) 0x10, (byte) 0x0A, (byte) 0x02, 
			(byte) 0x07, (byte) 0x00, (byte) 0xED, (byte) 0x10, 
			(byte) 0x03};
		try {
			RXTXPort = (SerialPort) ID.open("test", 2000);
		} catch (PortInUseException e) {}
		try {
			in = RXTXPort.getInputStream();
			out = RXTXPort.getOutputStream();
		} catch (IOException e) {}
/*-------------------------------------------------------------------------
|   Setup the port and open it.
--------------------------------------------------------------------------*/
		try {
			RXTXPort.addEventListener(this);
		} catch (TooManyListenersException e) {}
		RXTXPort.notifyOnDataAvailable(true);
		try {
			RXTXPort.setSerialPortParams(9600, RXTXPort.DATABITS_8, RXTXPort.STOPBITS_1, RXTXPort.PARITY_NONE);
		} catch (UnsupportedCommOperationException e) {}
/*-------------------------------------------------------------------------
|  Just write something to show it can be done.
--------------------------------------------------------------------------*/
		try {
			out.write(dump);
		}catch (IOException e) {}
		readThread=new Thread(this);
		readThread.start();
	}
	public void run(){
		try{
			Thread.sleep(100);
		}catch (InterruptedException e) {}
	}
	public void serialEvent(SerialPortEvent Event) {
		byte[] buffer = new byte[512];
		int ReadCount=0,i;

/*-------------------------------------------------------------------------
|  Need to add more tests in here.   We will do that after the polling 
|  method is replaced with sigaction.
--------------------------------------------------------------------------*/
		switch(Event.getEventType()){
			case SerialPortEvent.DATA_AVAILABLE:
				try {
					ReadCount=in.read(buffer);
				} catch (IOException e) {}
				for(i=0;i<ReadCount-1;i++){
					System.out.print(Byte.toString(buffer[i]) + " ");
				}
				System.out.println(Byte.toString(buffer[ReadCount]) + " ");
				break;
			default: 
				System.out.println("Untested SerialPortEvent");
				break;
		}
	}
}
